Attribute VB_Name = "Polynx"
Option Explicit

Type Poly       'To store coefficients for all grid values
    Vg As Single
    X() As Double
End Type
Global PolyVg1() As Poly

Public Sub TdFileToPoly(Filename As String, Np As Integer)
Dim F As Integer
Dim S As String

    F = IsOpen(Filename, "R", 10)
    If F <> 0 Then
        S = Input(LOF(F), F)
        XClose F, 10
        Base.TextOut.Text = GetFname(Filename) & vbCrLf
        TdfToPoly Np - 1, S
    Else
        Exit Sub   'Error
    End If
End Sub

Public Sub TdfToPoly(Np As Integer, Tdf As String)
'Store NP+1 coeficients for each grid bias in PolyVg1
Dim S As String
Dim I As Integer
Dim J As Integer
Dim G As Integer
Dim CurVg1 As Single
Dim Z As Single
Dim X() As Double
Dim N As Integer
Dim PA() As Single
Dim PB() As Single

    G = 1
    I = 1
    S = Trim(Substring(Tdf, I, vbCrLf))
    Do While Len(S)
        J = 1
        CurVg1 = Val(Substring(S, 3, " "))
        ReDim PA(0)
        ReDim PB(0)
        ReDim Preserve PolyVg1(G)
        ReDim Preserve PolyVg1(G).X(Np + 1)
        Do
            ReDim Preserve PA(J)
            ReDim Preserve PB(J)
            PA(J) = Val(Substring(S, 1, " "))
            PB(J) = Val(Substring(S, 2, " "))
            I = I + 1
            J = J + 1
            S = Trim(Substring(Tdf, I, vbCrLf))
        Loop While (Val(Substring(S, 3, " ")) = CurVg1) And (Len(S) > 0)
'        Debug.Print J - 1
        If POLYNX(PolyVg1(G).X, J - 1, Np, PA, PB) = 0 Then
            PolyVg1(G).Vg = CurVg1
        Else
            Base.TextOut = "POLYNX ERROR !"
            ReDim PolyVg1(0)
            Exit Sub
        End If
        G = G + 1
    Loop
    For G = 1 To UBound(PolyVg1)
        Base.TextOut.Text = Base.TextOut.Text & vbCrLf & Str(PolyVg1(G).Vg) & vbCrLf
        For J = 1 To Np + 1
            Base.TextOut.Text = Base.TextOut.Text & Str(PolyVg1(G).X(J)) & "  "
        Next J
    Next G
'    Base.TextOut.Visible = True
End Sub

Public Sub POLYNXTest()

'//exemple d'utilisation :
'//X est un tableau de 4 reels doubles (ou tableau dynamique de NP+1 reels doubles)
'//PA est un tableau de 6 reels (ou tableau dynamique de N reels)
'//PB est un tableau de 6 reels (ou tableau dynamique de N reels)
'//
'//PA[1]=0;PB[1]=0
'//PA[2]=1;PB[2]=1
'//PA[3]=2;PB[3]=8
'//PA[4]=3;PB[4]=27
'//PA[5]=4;PB[5]=64
'//PA[6]=10;PB[6]=1000
'//N est un entier=6 //nb paires
'//NP est un entier=3 //polynome de degr 3
'//
'//POLYNX(X,N,NP,PA,PB)
'//rsultats a=X[1], b=X[2], c=X[3], d=X[4] pour y=ax**3+bx**2+cx+d

Dim X(4) As Double
Dim N As Integer
Dim Np As Integer
Dim PA(1 To 6) As Single
Dim PB(1 To 6) As Single
Dim I As Integer

    PA(1) = 0
    PA(2) = 1
    PA(3) = 2
    PA(4) = 3
    PA(5) = 4
    PA(6) = 10
    
    PB(1) = 0
    PB(2) = 1
    PB(3) = 8
    PB(4) = 27
    PB(5) = 64
    PB(6) = 1000
    
    If POLYNX(X, 6, 3, PA, PB) = 0 Then
        Debug.Print "OK";
    End If
    For I = 1 To 4
        Debug.Print X(I);
    Next I
    Debug.Print
End Sub


'POLYNX(X,N,NP,PA,PB)
Public Function POLYNX(X() As Double, N As Integer, Np As Integer, PA() As Single, PB() As Single) As Integer
'//rgression polynomiale degr NP, N points, PA:table des X, PB:table des Y,
'//renvoie 0 si OK, 1 si KO
'//N>NP

'NP1,I,NEX,J,JJ,I1,JJJ,NM sont des entiers
'AA est un tableau dynamique de NP+1 par NP+1 reel double
'B  est un tableau dynamique de NP+1 reel double
Dim NP1 As Integer
Dim I As Integer
Dim NEX As Integer
Dim J As Integer
Dim JJ As Integer
Dim I1 As Integer
Dim JJJ As Integer
Dim NM As Integer
Dim AA() As Single
Dim B() As Single

On Error GoTo POLYNXERR

'si NP<=0 ou NP>=N alors renvoyer 1
'NP1 = NP + 1
    NP1 = Np + 1
    If Np <= 0 Or Np >= N Then
        POLYNX = 1
        Exit Function
    End If
'pour I=1  NP1
'    AA [I,1] = 0
'    NEX = NP * 2 + 1 - I
'    pour J=1  N
'        AA[I,1]+=EXLDB(PA[J],NEX)
'    fin
'fin
    
    ReDim AA(1 To NP1, 1 To NP1)
    For I = 1 To NP1
        AA(I, 1) = 0
        NEX = Np * 2 + 1 - I
        For J = 1 To N
            AA(I, 1) = AA(I, 1) + EXLDB(PA(J), NEX)
        Next J
    Next I
'pour I=1  NP1
'    AA [I,NP1] = 0
'    NEX = NP1 - I
'    pour J=1  N
'        AA[I,NP1]+=EXLDB(PA[J],NEX)
'    fin
'fin
    For I = 1 To NP1
        AA(I, NP1) = 0
        NEX = NP1 - I
        For J = 1 To N
            AA(I, NP1) = AA(I, NP1) + EXLDB(PA(J), NEX)
        Next J
    Next I
'pour I=1  NP1
'    B [I] = 0
'    NEX = NP1 - I
'    pour J=1  N
'        B[I]+=EXLDB(PA[J],NEX)*PB[J]
'    fin
'fin
    ReDim B(1 To NP1)
    For I = 1 To NP1
        B(I) = 0
        NEX = NP1 - I
        For J = 1 To N
            B(I) = B(I) + EXLDB(PA(J), NEX) * PB(J)
        Next J
    Next I
'pour I=2  NP1
'    JJ = I
'    I1 = I - 1
'    pour J=1  I1
'        JJ--
'        JJJ = J + 1
'        AA[JJ,JJJ]=AA[I,1]
'    fin
'fin
    For I = 2 To NP1
        JJ = I
        I1 = I - 1
        For J = 1 To I1
            JJ = JJ - 1
            JJJ = J + 1
            AA(JJ, JJJ) = AA(I, 1)
        Next J
    Next I
'NM = NP1
'pour I=1  NP
'    JJJ = NP1
'    JJ = I
'    NM--
'    pour J=1  NM
'        JJJ--
'        JJ++
'        AA[JJ,JJJ]=AA[I,NP1]
'    fin
'fin
    NM = NP1
    For I = 1 To Np
        JJJ = NP1
        JJ = I
        NM = NM - 1
        For J = 1 To NM
            JJJ = JJJ - 1
            JJ = JJ + 1
            AA(JJ, JJJ) = AA(I, NP1)
        Next J
    Next I
'renvoyer SYLEQ(AA, B, X, NP1, NP1)
    POLYNX = SYLEQ(AA, B, X, NP1, NP1)
'// fin de la fonction POLYNX
    Exit Function
POLYNXERR:
    MsgBox "POLYNX " & err.Description
    err.Clear
    POLYNX = 1
'//---------------------
End Function



'fonction SYLEQ(AA, B, X, N, NP1)
Function SYLEQ(AA() As Single, B() As Single, X() As Double, N As Integer, Np As Integer) As Integer
'R,TX,TZ sont des reels doubles
'NM1,I,K,M,J,KP1,IEIE,IP1 sont des entiers
Dim R As Double
Dim TX As Double
Dim Tz As Double
Dim NM1 As Integer
Dim I As Integer
Dim K As Integer
Dim M As Integer
Dim J As Integer
Dim KP1 As Integer
Dim IEIE As Integer
Dim IP1 As Integer

'NM1 = N - 1
    NM1 = N - 1
'pour K=1  NM1
'    I = K + 1
'    M = K
    For K = 1 To NM1
        I = K + 1
        M = K
'E2:
E2:
'    si ABS(AA[I,K])-ABS(AA[M,K])>0 alors M=I
'    si I-N>=0 alors goto E6
'    I = I + 1
'    GoTo E2
        If Abs(AA(I, K)) - Abs(AA(M, K)) > 0 Then M = I
        If I - N >= 0 Then GoTo E6
        I = I + 1
        GoTo E2
'E6:
E6:
'    si AA[M,K]=0 alors renvoyer 1
'    si M-K=0 alors goto E11
'    pour J=K  N
'        R=AA[K,J]
'        AA[K,J]=AA[M,J]
'        AA [M,J] = R
'    fin
'    R=B[K]
'    B[K]=B[M]
'    B [M] = R
        If AA(M, K) = 0 Then
            SYLEQ = 1
            Exit Function
        End If
        If M - K = 0 Then GoTo E11
        For J = K To N
            R = AA(K, J)
            AA(K, J) = AA(M, J)
            AA(M, J) = R
        Next J
        R = B(K)
        B(K) = B(M)
        B(M) = R
'E11:
E11:
'    KP1 = K + 1
'    pour I=KP1  N
'        R=AA[I,K]/AA[K,K]
'        AA [I,K] = 0
'        pour J=KP1  N
'            AA[I,J]-=R*AA[K,J]
'            A(J2DIM(I,J,NP1))=A(J2DIM(I,J,NP1))-R*A(J2DIM(K,J,NP1)) from Fortran code
'        fin
'        B[I]=B[I]-R*B[K]
'    fin
'fin
        KP1 = K + 1
        For I = KP1 To N
            R = AA(I, K) / AA(K, K)
            AA(I, K) = 0
            For J = KP1 To N
                AA(I, J) = AA(I, J) - R * AA(K, J)
            Next J
            B(I) = B(I) - R * B(K)
        Next I
    Next K
'    X[N]=B[N]/AA[N,N]
    X(N) = B(N) / AA(N, N)
'    pour IEIE=1  NM1
'        I = N - IEIE
'        TX = 0
'        IP1 = I + 1
'        pour J=IP1  N
'            TX=TX-AA[I,J]*X[J]
'        fin
'        si AA[I,I]=0 renvoyer 1
'    X[I]=(B[I]+TX)/AA[I,I]
'fin
    For IEIE = 1 To NM1
        I = N - IEIE
        TX = 0
        IP1 = I + 1
        For J = IP1 To N
            TX = TX - AA(I, J) * X(J)
        Next J
        If AA(I, I) = 0 Then
            SYLEQ = 1
            Exit Function
        End If
        X(I) = (B(I) + TX) / AA(I, I)
    Next IEIE
'renvoyer 0
    SYLEQ = 0
'// fin de la fonction SYLEQ

End Function

'
'fonction EXLDB(R, NEX)
Public Function EXLDB(R As Single, NEX As Integer) As Double
''** Elve R  la puissance NEX **
'I est un entier
Dim I As Integer
'EXLDB_ est un reel double=1.0
    EXLDB = 1
'si NEX<=0 alors renvoyer EXLDB_
'EXLDB_ = R
'si NEX=1 alors renvoyer EXLDB_
'pour I=2  NEX
'    EXLDB_ = EXLDB_ * R
'fin
    If NEX <= 0 Then Exit Function
    EXLDB = R
    If NEX = 1 Then Exit Function
    For I = 2 To NEX
        EXLDB = EXLDB * R
    Next I
'renvoyer EXLDB_
'// fin de la fonction EXLDB

End Function

